/********************************************************************************
 * ePIMSs $Source: DataStore.java $
 * ePIMSs $Project: com.epimss.services $
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author: st.clair.clarke $
 *
 * @source $Source: DataStore.java $
 * @path $FPath: src-java/com/epimss/services/datastores $
 * @project $Project: com.epimss.services $
 * @generics $Generic: mainline $
 *
 * @lastChangedBy	 $Author: st.clair.clarke $
 * @lastChangedDate $Date: 2011/05/02 16:30:57 $
 *
 * @version $Revision: 1.3 $ $Date: 2011/05/02 16:30:57 $
 *
 * @changeRequest $CR: com.epimss.services000006 $
 * @state $State: Develop/Test $
 ********************************************************************************/



package _com.epimss.lab.db;


import javax.jdo.JDOHelper
import javax.jdo.PersistenceManager
import javax.jdo.PersistenceManagerFactory





/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  May 2, 2011 12:55:42 AM by St Clair Clarke
 * @since    1.0
 * @version  $Revision: 1.3 $ $Date: 2011/05/02 16:30:57 $
 */
@Singleton
class DataStore
{
    
    
    PersistenceManagerFactory objectDbPMF()
    {
        PersistenceManagerFactory pmf
        def inStream
        def properties
        
        try
        {
            inStream = this.getClass().getResourceAsStream("/resrc/resource/bundle/objectdb.properties");
            assert inStream
            
            properties = new Properties();
            properties.load( inStream );
            
            
            assert properties
            
            
            // Instantiabe the PMF with the properties set in the properties file
            pmf = JDOHelper.getPersistenceManagerFactory( properties );
            assert pmf
            
        }
        catch(Exception e)
        {
            println "com.epimss.lab.db.DataStore.objectDbPMF(), "
            e.printStackTrace()
        }
        
        return pmf
    }
}   // end class Db4oDataStore
