/********************************************************************************
 * ePIMSs $Source$
 * ePIMSs $Project$
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author$
 *
 * @source $Source$
 * @path $FPath$

 * @project $Project$
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author$
 * @lastChangedDate $Date$
 *
 * @version $Revision$ $Date$
 *
 * @changeRequest $CR$
 * @state $State$
 ********************************************************************************/


package _com.epimss.lab.ui.toxicology;


/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  September 17, 2010, 9:30:30 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */

import _com.epimss.lab.ui.misc.OtherRqstForm;

import _com.epimss.lab.ui.util.PropagateGroupVisibilityToggler;
import _com.epimss.lab.ui.util.WidgetEventValidator;

import com.richclientgui.toolbox.propagate.PropagateComposite;
import com.richclientgui.toolbox.propagate.PropagateGroup;

import org.eclipse.swt.SWT;

import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import org.eclipse.ui.forms.widgets.FormToolkit;

/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  June 21, 2011 2:57:54 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */
public class TherapeauticDrugScreenRqstForm extends Composite
{
    //~ Instance fields --------------------------------------------------------

    private final FormToolkit  toolkit                           = new FormToolkit( Display.getCurrent() );
    private Button             antiepilepticsCBtn;
    private Button             antipsychoticsCBtn;
    private Button             aspirinCBtn;
    private Button             cardiotoxinsCBtn;
    private Button             digoxinCBtn;
    private Button             dilantinCBtn;
    private Button             hepatotoxinsCBtn;
    private Button             lithiumCBtn;
    private Button             otherCBtn;
    private Button             phenobarbCBtn;
    private Button             tegretolCBtn;

    private Button[]           antiepilepticsCBtns;
    private Button[]           antipsychoticsCBtns;
    private Button[]           cardiotoxinsCBtns;
    private Button[]           hepatotoxinsCBtns;

    private OtherRqstForm      otherRqstForm;
    private PropagateComposite rootPrpgteCmpst;
    private PropagateComposite therapeauticDrugScreenPrpgteCmpst;
    private PropagateGroup     antiepilepticsPrpgteGrp;
    private PropagateGroup     antipsychoticsPrpgteGrp;
    private PropagateGroup     cardiotoxinsPrpgteGrp;
    private PropagateGroup     hepatotoxinsPrpgteGrp;
    private PropagateGroup     otherPrpgteGrp;

    private PropagateGroup[]   prpgteGrps;

    //~ public -----------------------------------------------------------------

    /**
     * Creates a new <code>TherapeauticDrugScreenRqstForm</code> object.
     *
     * @created  June 21, 2011 2:58:21 PM by St Clair Clarke
     *
     * @param    parent  <code>Composite</code> TODO!
     * @param    style   <code>int</code> TODO!
     *
     * @since    1.0
     */
    public TherapeauticDrugScreenRqstForm( Composite parent, int style )
    {
        super( parent, style );

        try
        {
            createContents();

            antiepilepticsCBtns = new Button[] { dilantinCBtn, phenobarbCBtn, tegretolCBtn };
            antipsychoticsCBtns = new Button[] { lithiumCBtn };
            cardiotoxinsCBtns   = new Button[] { digoxinCBtn };
            hepatotoxinsCBtns   = new Button[] { aspirinCBtn };

            prpgteGrps          = new PropagateGroup[] { antiepilepticsPrpgteGrp, antipsychoticsPrpgteGrp, cardiotoxinsPrpgteGrp, hepatotoxinsPrpgteGrp, otherPrpgteGrp };

            for( int i = 0; i < prpgteGrps.length; i++ )
            {
                prpgteGrps[ i ].setVisible( false );

            }   // end for

        }
        catch( Exception e )
        {
            System.err.println( "com.epimss.lab.ui.toxicology.TherapeauticDrugScreenRqstForm.TherapeauticDrugScreenRqstForm(parent, style), " + e );

        }   // end try-catch

    }   // end ctor TherapeauticDrugScreenRqstForm

    //~ Methods ----------------------------------------------------------------

    /**
     * The <code>createContents()</code> method TODO!
     *
     * @created  June 21, 2011 3:04:49 PM by St Clair Clarke
     * @since    1.0
     */
    private void createContents()
    {
        addDisposeListener( new DisposeListener()
            {
                @Override
                public void widgetDisposed( DisposeEvent e )
                {
                    toolkit.dispose();

                }   // end method widgetDisposed

            } );
        toolkit.adapt( this );
        toolkit.paintBordersFor( this );
        setLayout( new GridLayout() );

        {
            rootPrpgteCmpst = new PropagateComposite( this, SWT.NONE );
            rootPrpgteCmpst.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
            rootPrpgteCmpst.setData( "name", "rootPrpgteCmpst" );
            toolkit.adapt( rootPrpgteCmpst );
            toolkit.paintBordersFor( rootPrpgteCmpst );
            rootPrpgteCmpst.setLayout( new GridLayout( 1, false ) );

            {
                therapeauticDrugScreenPrpgteCmpst = new PropagateComposite( rootPrpgteCmpst, SWT.NONE );
                therapeauticDrugScreenPrpgteCmpst.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                therapeauticDrugScreenPrpgteCmpst.setData( "name", "therapeauticDrugScreenPrpgteCmpst" );
                toolkit.adapt( therapeauticDrugScreenPrpgteCmpst );
                toolkit.paintBordersFor( therapeauticDrugScreenPrpgteCmpst );
                therapeauticDrugScreenPrpgteCmpst.setLayout( new GridLayout( 2, false ) );

                {
                    antiepilepticsCBtn = new Button( therapeauticDrugScreenPrpgteCmpst, SWT.CHECK );
                    antiepilepticsCBtn.addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                PropagateGroupVisibilityToggler.toggleChildrenOnControlButtonSelection( antiepilepticsCBtn, antiepilepticsCBtns, antiepilepticsPrpgteGrp );
                                isFormValid();

                            }   // end method widgetSelected

                        } );
                    antiepilepticsCBtn.setData( "name", "antiepilepticsCBtn" );
                    toolkit.adapt( antiepilepticsCBtn, true, true );
                    antiepilepticsCBtn.setText( "Anti-epileptics" );

                }

                {
                    antiepilepticsPrpgteGrp = new PropagateGroup( therapeauticDrugScreenPrpgteCmpst, SWT.NONE );
                    antiepilepticsPrpgteGrp.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                    antiepilepticsPrpgteGrp.setData( "name", "antiepilepticsPrpgteGrp" );
                    toolkit.adapt( antiepilepticsPrpgteGrp );
                    toolkit.paintBordersFor( antiepilepticsPrpgteGrp );
                    antiepilepticsPrpgteGrp.setLayout( new GridLayout( 3, false ) );

                    {
                        dilantinCBtn = new Button( antiepilepticsPrpgteGrp, SWT.CHECK );
                        dilantinCBtn.addSelectionListener( new SelectionAdapter()
                            {
                                @Override
                                public void widgetSelected( SelectionEvent e )
                                {
                                    PropagateGroupVisibilityToggler.toggleControlButtonOnChildrenSelection( antiepilepticsCBtn, antiepilepticsCBtns, antiepilepticsPrpgteGrp );
                                    isFormValid();

                                }   // end method widgetSelected

                            } );
                        dilantinCBtn.setData( "name", "dilantinCBtn" );
                        toolkit.adapt( dilantinCBtn, true, true );
                        dilantinCBtn.setText( "Dilantin" );

                    }

                    {
                        phenobarbCBtn = new Button( antiepilepticsPrpgteGrp, SWT.CHECK );
                        phenobarbCBtn.addSelectionListener( new SelectionAdapter()
                            {
                                @Override
                                public void widgetSelected( SelectionEvent e )
                                {
                                    PropagateGroupVisibilityToggler.toggleControlButtonOnChildrenSelection( antiepilepticsCBtn, antiepilepticsCBtns, antiepilepticsPrpgteGrp );
                                    isFormValid();

                                }   // end method widgetSelected

                            } );
                        toolkit.adapt( phenobarbCBtn, true, true );
                        phenobarbCBtn.setText( "Phenobarb" );

                    }

                    {
                        tegretolCBtn = new Button( antiepilepticsPrpgteGrp, SWT.CHECK );
                        tegretolCBtn.addSelectionListener( new SelectionAdapter()
                            {
                                @Override
                                public void widgetSelected( SelectionEvent e )
                                {
                                    PropagateGroupVisibilityToggler.toggleControlButtonOnChildrenSelection( antiepilepticsCBtn, antiepilepticsCBtns, antiepilepticsPrpgteGrp );
                                    isFormValid();

                                }   // end method widgetSelected

                            } );
                        toolkit.adapt( tegretolCBtn, true, true );
                        tegretolCBtn.setText( "Tegretol" );

                    }

                }

                {
                    antipsychoticsCBtn = new Button( therapeauticDrugScreenPrpgteCmpst, SWT.CHECK );
                    antipsychoticsCBtn.addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                PropagateGroupVisibilityToggler.toggleChildrenOnControlButtonSelection( antipsychoticsCBtn, antipsychoticsCBtns, antipsychoticsPrpgteGrp );
                                isFormValid();

                            }   // end method widgetSelected

                        } );
                    toolkit.adapt( antipsychoticsCBtn, true, true );
                    antipsychoticsCBtn.setText( "Anti-psychotics" );

                }

                {
                    antipsychoticsPrpgteGrp = new PropagateGroup( therapeauticDrugScreenPrpgteCmpst, SWT.NONE );
                    antipsychoticsPrpgteGrp.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                    antipsychoticsPrpgteGrp.setText( "" );
                    toolkit.adapt( antipsychoticsPrpgteGrp );
                    toolkit.paintBordersFor( antipsychoticsPrpgteGrp );
                    antipsychoticsPrpgteGrp.setLayout( new GridLayout( 1, false ) );

                    {
                        lithiumCBtn = new Button( antipsychoticsPrpgteGrp, SWT.CHECK );
                        lithiumCBtn.addSelectionListener( new SelectionAdapter()
                            {
                                @Override
                                public void widgetSelected( SelectionEvent e )
                                {
                                    PropagateGroupVisibilityToggler.toggleControlButtonOnChildrenSelection( antipsychoticsCBtn, antipsychoticsCBtns, antipsychoticsPrpgteGrp );
                                    isFormValid();

                                }   // end method widgetSelected

                            } );
                        lithiumCBtn.setData( "name", "lithiumCBtn" );
                        toolkit.adapt( lithiumCBtn, true, true );
                        lithiumCBtn.setText( "Lithium" );

                    }

                }

                {
                    cardiotoxinsCBtn = new Button( therapeauticDrugScreenPrpgteCmpst, SWT.CHECK );
                    cardiotoxinsCBtn.addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                PropagateGroupVisibilityToggler.toggleChildrenOnControlButtonSelection( cardiotoxinsCBtn, cardiotoxinsCBtns, cardiotoxinsPrpgteGrp );
                                isFormValid();

                            }   // end method widgetSelected

                        } );
                    cardiotoxinsCBtn.setData( "name", "cardiotoxinsCBtn" );
                    toolkit.adapt( cardiotoxinsCBtn, true, true );
                    cardiotoxinsCBtn.setText( "Cardiotoxins" );

                }

                {
                    cardiotoxinsPrpgteGrp = new PropagateGroup( therapeauticDrugScreenPrpgteCmpst, SWT.NONE );
                    cardiotoxinsPrpgteGrp.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                    cardiotoxinsPrpgteGrp.setText( "" );
                    toolkit.adapt( cardiotoxinsPrpgteGrp );
                    toolkit.paintBordersFor( cardiotoxinsPrpgteGrp );
                    cardiotoxinsPrpgteGrp.setLayout( new GridLayout( 1, false ) );

                    {
                        digoxinCBtn = new Button( cardiotoxinsPrpgteGrp, SWT.CHECK );
                        digoxinCBtn.addSelectionListener( new SelectionAdapter()
                            {
                                @Override
                                public void widgetSelected( SelectionEvent e )
                                {
                                    PropagateGroupVisibilityToggler.toggleControlButtonOnChildrenSelection( cardiotoxinsCBtn, cardiotoxinsCBtns, cardiotoxinsPrpgteGrp );
                                    isFormValid();

                                }   // end method widgetSelected

                            } );
                        toolkit.adapt( digoxinCBtn, true, true );
                        digoxinCBtn.setText( "Digoxin" );

                    }

                }

                {
                    hepatotoxinsCBtn = new Button( therapeauticDrugScreenPrpgteCmpst, SWT.CHECK );
                    hepatotoxinsCBtn.addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                PropagateGroupVisibilityToggler.toggleChildrenOnControlButtonSelection( hepatotoxinsCBtn, hepatotoxinsCBtns, hepatotoxinsPrpgteGrp );
                                isFormValid();

                            }   // end method widgetSelected

                        } );
                    toolkit.adapt( hepatotoxinsCBtn, true, true );
                    hepatotoxinsCBtn.setText( "Hepatotoxins" );

                }

                {
                    hepatotoxinsPrpgteGrp = new PropagateGroup( therapeauticDrugScreenPrpgteCmpst, SWT.NONE );
                    hepatotoxinsPrpgteGrp.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                    hepatotoxinsPrpgteGrp.setText( "" );
                    toolkit.adapt( hepatotoxinsPrpgteGrp );
                    toolkit.paintBordersFor( hepatotoxinsPrpgteGrp );
                    hepatotoxinsPrpgteGrp.setLayout( new GridLayout( 1, false ) );

                    {
                        aspirinCBtn = new Button( hepatotoxinsPrpgteGrp, SWT.CHECK );
                        aspirinCBtn.addSelectionListener( new SelectionAdapter()
                            {
                                @Override
                                public void widgetSelected( SelectionEvent e )
                                {
                                    PropagateGroupVisibilityToggler.toggleControlButtonOnChildrenSelection( hepatotoxinsCBtn, hepatotoxinsCBtns, hepatotoxinsPrpgteGrp );
                                    isFormValid();

                                }   // end method widgetSelected

                            } );
                        toolkit.adapt( aspirinCBtn, true, true );
                        aspirinCBtn.setText( "Aspirin (Salicylate)" );

                    }

                }

                {
                    otherCBtn = new Button( therapeauticDrugScreenPrpgteCmpst, SWT.CHECK );
                    otherCBtn.addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                WidgetEventValidator.onOtherCheckButtonSelectionEvent( otherCBtn, otherPrpgteGrp, otherRqstForm.getRequestTxt() );
                                isFormValid();

                            }   // end method widgetSelected

                        } );
                    otherCBtn.setData( "name", "otherCBtn" );
                    toolkit.adapt( otherCBtn, true, true );
                    otherCBtn.setText( "Other" );

                }

                {
                    otherPrpgteGrp = new PropagateGroup( therapeauticDrugScreenPrpgteCmpst, SWT.NONE );
                    otherPrpgteGrp.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                    otherPrpgteGrp.setData( "name", "otherPrpgteGrp" );
                    toolkit.adapt( otherPrpgteGrp );
                    toolkit.paintBordersFor( otherPrpgteGrp );
                    otherPrpgteGrp.setLayout( new GridLayout( 1, false ) );

                    {
                        otherRqstForm = new OtherRqstForm( otherPrpgteGrp, SWT.NONE );
                        otherRqstForm.getRequestTxt()
                                     .addModifyListener( new ModifyListener()
                                {
                                    @Override
                                    public void modifyText( ModifyEvent e )
                                    {
                                        isFormValid();

                                    }   // end method modifyText

                                } );
                        otherRqstForm.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                        otherRqstForm.setData( "name", "otherRqstForm" );
                        toolkit.adapt( otherRqstForm );
                        toolkit.paintBordersFor( otherRqstForm );

                    }

                }

            }

        }

    }   // end method createContents


    /**
     * Retrieves the <code>antiepilepticsCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getAntiepilepticsCBtn()
    {
        return( antiepilepticsCBtn );

    }   // end method getAntiepilepticsCBtn


    /**
     * Retrieves the <code>antipsychoticsCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getAntipsychoticsCBtn()
    {
        return( antipsychoticsCBtn );

    }   // end method getAntipsychoticsCBtn


    /**
     * Retrieves the <code>aspirinCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getAspirinCBtn()
    {
        return( aspirinCBtn );

    }   // end method getAspirinCBtn


    /**
     * Retrieves the <code>cardiotoxinsCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getCardiotoxinsCBtn()
    {
        return( cardiotoxinsCBtn );

    }   // end method getCardiotoxinsCBtn


    /**
     * Retrieves the <code>formValid</code> property from this bean.
     *
     * @created  June 30, 2011 4:38:44 PM by St Clair Clarke
     *
     * @return   <code>Boolean</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Boolean isFormValid()
    {
        if( WidgetEventValidator.onCheckButtonSelectionEvent( antiepilepticsCBtn, antiepilepticsCBtns ) )
        {
            return( true );

        }   // end if

        if( WidgetEventValidator.onCheckButtonSelectionEvent( antipsychoticsCBtn, antipsychoticsCBtns ) )
        {
            return( true );

        }   // end if

        if( WidgetEventValidator.onCheckButtonSelectionEvent( cardiotoxinsCBtn, cardiotoxinsCBtns ) )
        {
            return( true );

        }   // end if

        if( WidgetEventValidator.onCheckButtonSelectionEvent( hepatotoxinsCBtn, hepatotoxinsCBtns ) )
        {
            return( true );

        }   // end if

        if( WidgetEventValidator.onTextModifyEventSizeValidator( otherRqstForm.getRequestTxt(), 2 ) )
        {
            return( true );

        }   // end if

        return( false );

    }   // end method isFormValid


    /**
     * Retrieves the <code>digoxinCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getDigoxinCBtn()
    {
        return( digoxinCBtn );

    }   // end method getDigoxinCBtn


    /**
     * Retrieves the <code>dilantinCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getDilantinCBtn()
    {
        return( dilantinCBtn );

    }   // end method getDilantinCBtn


    /**
     * Retrieves the <code>hepatotoxinsCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getHepatotoxinsCBtn()
    {
        return( hepatotoxinsCBtn );

    }   // end method getHepatotoxinsCBtn


    /**
     * Retrieves the <code>lithiumCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getLithiumCBtn()
    {
        return( lithiumCBtn );

    }   // end method getLithiumCBtn


    /**
     * Retrieves the <code>otherCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getOtherCBtn()
    {
        return( otherCBtn );

    }   // end method getOtherCBtn


    /**
     * Retrieves the <code>otherRqstForm</code> property from this bean.
     *
     * @created  June 21, 2011 4:59:04 PM by St Clair Clarke
     *
     * @return   <code>OtherRqstForm</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected OtherRqstForm getOtherRqstForm()
    {
        return( otherRqstForm );

    }   // end method getOtherRqstForm


    /**
     * Retrieves the <code>phenobarbCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getPhenobarbCBtn()
    {
        return( phenobarbCBtn );

    }   // end method getPhenobarbCBtn


    /**
     * Retrieves the <code>tegretolCBtn</code> property from this bean.
     *
     * @created  June 21, 2011 4:56:30 PM by St Clair Clarke
     *
     * @return   <code>Button</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected Button getTegretolCBtn()
    {
        return( tegretolCBtn );

    }   // end method getTegretolCBtn

}   // end class TherapeauticDrugScreenRqstForm
